       IDENTIFICATION DIVISION.
       PROGRAM-ID.    MENU02.

      ******************************************************
      * ACTUALIZACION DE CLIENTES
      ******************************************************

       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SOURCE-COMPUTER.       IBM.
       OBJECT-COMPUTER.       IBM.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.

           COPY "COBLIB\HTML-OUT.SEL".
           
           COPY "CLIENTES.SEL".

       DATA DIVISION.

       FILE SECTION.

       COPY "COBLIB\HTML-OUT.FD".
       
       COPY "CLIENTES.FD".

       WORKING-STORAGE SECTION.

       COPY "COBLIB\TEMPLATE.WSS".
       
       77  STAT-CAT                  PIC XX.
       77  WF-CLIENTES               PIC X(50).
       77  FLAG-ROW                  PIC 9.
       77  IK                        PIC X.
       77  L-DESCUENTO               PIC Z9.99.
       77  I                         PIC 9(02).
       77  MAX-ROWS                  PIC 9(02) VALUE 10.

      *<COBHTTPD-DATA PREFIX="LS-">
       01  WEB-DATA.
           02 LS-LOGINOK             PIC X(10).
           02 LS-FUNC                PIC X(10).
           02 LS-CLI-FIN             PIC 9(06).
           02 LS-CLAVE               PIC 9(06).
           02 LS-RAZSOC              PIC X(45).
           02 LS-NOMBRE              PIC X(45).
           02 LS-DIRECCION           PIC X(60).
           02 LS-POBLACION           PIC X(35).
           02 LS-CODIGO              PIC 9(06).
           02 LS-TELEFONOS           PIC X(30).
           02 LS-RFC                 PIC X(15).
           02 LS-CUENTACTB           PIC X(15).
           02 LS-DESCUENTO           PIC 99V99.
           02 LS-PLAZO-NORMAL        PIC 9(03).

       LINKAGE SECTION.

       COPY "COBLIB\LS-HTTP.FDT".

       PROCEDURE DIVISION USING HTTP-CONTROL HTTP-DATA-INP.
       DECLARATIVES.
       BLOQUEO SECTION.
           USE AFTER STANDARD ERROR PROCEDURE ON HTML-OUT CLIENTES.
       END DECLARATIVES.
       PROGRAMA SECTION.
       0000-START.
           MOVE HTTP-DATA-INP  TO WEB-DATA.
           
           IF LS-LOGINOK NOT = "COB1357"
              MOVE SPACES TO HTTP-DATA-INP
              CALL "MENU01" USING HTTP-CONTROL HTTP-DATA-INP
              GO TO 999-EXIT.

           PERFORM TPL-OPEN-FILE.
           
           MOVE "CLIENTES.DAT" TO WF-CLIENTES.
           
           OPEN I-O CLIENTES.
           IF STAT-CAT = "35"
              CLOSE CLIENTES
              OPEN OUTPUT CLIENTES
              CLOSE CLIENTES
              OPEN I-O CLIENTES.
           
           IF STAT-CAT NOT = "00"
              PERFORM 900-ERROR-OPEN
              CLOSE CLIENTES
              CLOSE HTML-OUT
              GO 999-EXIT.
              
           IF LS-FUNC = SPACES
              MOVE "Browse" TO LS-FUNC.
              
              
           IF LS-FUNC = "Save"
              PERFORM 500-SAVE
           ELSE
           IF LS-FUNC = "Update"
              PERFORM 530-UPDATE
           ELSE
           IF LS-FUNC = "DelOk"
              PERFORM 540-DELETE
           ELSE
           IF LS-FUNC = "New"
              PERFORM 100-SHOW-NEW
           ELSE
           IF LS-FUNC = "Modif"
              PERFORM 200-SHOW-MODIF
           ELSE
           IF LS-FUNC = "Del"
              PERFORM 300-SHOW-DELETE.

           IF LS-FUNC = "First"
              PERFORM 700-PREPARA-FIRST
              PERFORM 700-BROWSE
           ELSE
           IF LS-FUNC = "Prev"
              PERFORM 700-PREPARA-PREV
              PERFORM 700-BROWSE
           ELSE
           IF LS-FUNC = "Next"
              PERFORM 700-PREPARA-NEXT
              PERFORM 700-BROWSE
           ELSE
           IF LS-FUNC = "Last"
              PERFORM 700-PREPARA-LAST
              PERFORM 700-BROWSE.
           
           IF LS-FUNC = "Browse"
              PERFORM 700-BROWSE-ALL.


           CLOSE CLIENTES.
           
           CLOSE HTML-OUT.

           GO TO 999-EXIT.
           
       100-SHOW-NEW.
           MOVE "FUNCION" TO VAR-NAME
           MOVE "Save"    TO VAR-VALUE
           PERFORM TPL-ADD-VAR
           MOVE "TIT_OPER" TO VAR-NAME
           MOVE "Registro Nuevo" TO VAR-VALUE.
           PERFORM TPL-ADD-VAR.
           MOVE "tpl\menu\act_cli_form.html" TO TPL-FILENAME.
           PERFORM TPL-ADD-FILENAME.
           
       200-SHOW-MODIF.
           MOVE LS-CLAVE TO C03-CLAVE
           READ CLIENTES INVALID KEY MOVE SPACE TO IK.
           IF STAT-CAT = "00"
              PERFORM 600-DATA-TO-FORM
              MOVE "FUNCION" TO VAR-NAME
              MOVE "Update"  TO VAR-VALUE
              PERFORM TPL-ADD-VAR
              MOVE "TIT_OPER" TO VAR-NAME
              MOVE "Modificando Registro" TO VAR-VALUE
              PERFORM TPL-ADD-VAR
              MOVE "tpl\menu\act_cli_form.html" TO TPL-FILENAME.
              PERFORM TPL-ADD-FILENAME.
              
       300-SHOW-DELETE.
           MOVE LS-CLAVE TO C03-CLAVE.
           READ CLIENTES INVALID KEY MOVE SPACE TO IK.
           PERFORM 600-DATA-TO-FORM.
           MOVE "FUNCION" TO VAR-NAME
           MOVE "DelOk" TO VAR-VALUE
           PERFORM TPL-ADD-VAR.
           MOVE "TIT_OPER" TO VAR-NAME
           MOVE "Eliminando Registro" TO VAR-VALUE
           PERFORM TPL-ADD-VAR.
           MOVE "tpl\menu\act_cli_form.html" TO TPL-FILENAME.
           PERFORM TPL-ADD-FILENAME.


           
       500-SAVE.
           IF LS-CLAVE = ZEROS
              MOVE "MSG_ERROR" TO VAR-NAME
              MOVE "** LA CLAVE DEBE SER MAYOR A CERO **" TO VAR-VALUE
              PERFORM TPL-ADD-VAR
              PERFORM 600-MEM-TO-FORM
              PERFORM 100-SHOW-NEW
           ELSE
              PERFORM 510-SAVE.
              
       510-SAVE.
           MOVE LS-CLAVE TO C03-CLAVE.
           READ CLIENTES INVALID KEY MOVE SPACE TO IK.
           IF STAT-CAT = "00"
              MOVE "msg_error" TO VAR-NAME
              MOVE "** CLIENTE YA EXISTE **" TO VAR-VALUE
              PERFORM TPL-ADD-VAR
              PERFORM 600-MEM-TO-FORM
              PERFORM 100-SHOW-NEW
           ELSE
              PERFORM 600-FORM-TO-DATA
              WRITE R-CLIENTES INVALID KEY MOVE SPACE TO IK
              END-WRITE

              PERFORM 700-BROWSE-ALL.
              
       530-UPDATE.
           MOVE LS-CLAVE TO C03-CLAVE.
           READ CLIENTES INVALID KEY MOVE SPACE TO IK.
           IF STAT-CAT = "00"
              PERFORM 600-FORM-TO-DATA
              REWRITE R-CLIENTES.
              
           PERFORM 700-BROWSE-ALL.


       540-DELETE.
           MOVE LS-CLAVE TO C03-CLAVE.
           READ CLIENTES INVALID KEY MOVE SPACE TO IK.
           IF STAT-CAT = "00"
              DELETE CLIENTES.
              
           PERFORM 700-BROWSE-ALL.

              

              
      * carga los datos de la forma a el archivo
       600-FORM-TO-DATA.
           MOVE LS-RAZSOC     TO C03-RAZSOC
           MOVE LS-NOMBRE     TO C03-NOMBRE
           MOVE LS-DIRECCION  TO C03-DIRECCION
           MOVE LS-POBLACION  TO C03-POBLACION
           MOVE LS-CODIGO     TO C03-CODIGO
           MOVE LS-TELEFONOS  TO C03-TELEFONOS
           MOVE LS-RFC        TO C03-RFC
           MOVE LS-CUENTACTB  TO C03-CUENTACTB
           MOVE LS-DESCUENTO  TO C03-DESCUENTO
           MOVE LS-PLAZO-NORMAL  TO C03-PLAZO-NORMAL.
           
      * carga los datos del archivo hacia la forma
       600-DATA-TO-FORM.
           MOVE "CLAVE" TO VAR-NAME
           MOVE LS-CLAVE TO VAR-VALUE
           PERFORM TPL-ADD-VAR.
           
           MOVE "RAZSOC"      TO VAR-NAME
           MOVE C03-RAZSOC    TO VAR-VALUE
           PERFORM TPL-ADD-VAR
           
           MOVE "NOMBRE"      TO VAR-NAME
           MOVE C03-NOMBRE    TO VAR-VALUE
           PERFORM TPL-ADD-VAR.
           
           MOVE "DIRECCION"   TO VAR-NAME
           MOVE C03-DIRECCION TO VAR-VALUE
           PERFORM TPL-ADD-VAR.
           
           MOVE "POBLACION"   TO VAR-NAME
           MOVE C03-POBLACION TO VAR-VALUE
           PERFORM TPL-ADD-VAR.
           
           MOVE "CODIGO"      TO VAR-NAME
           MOVE C03-CODIGO    TO VAR-VALUE
           PERFORM TPL-ADD-VAR.
           
           MOVE "TELEFONOS"   TO VAR-NAME
           MOVE C03-TELEFONOS TO VAR-VALUE
           PERFORM TPL-ADD-VAR.
           
           MOVE "RFC"         TO VAR-NAME
           MOVE C03-RFC       TO VAR-VALUE
           PERFORM TPL-ADD-VAR.
           
           MOVE "CUENTACTB"   TO VAR-NAME
           MOVE C03-CUENTACTB TO VAR-VALUE
           PERFORM TPL-ADD-VAR
           
           MOVE "DESCUENTO"   TO VAR-NAME
           MOVE C03-DESCUENTO TO L-DESCUENTO
           MOVE L-DESCUENTO   TO VAR-VALUE
           PERFORM TPL-ADD-VAR.
           
           MOVE "PLAZO"        TO VAR-NAME
           MOVE C03-PLAZO-NORMAL TO VAR-VALUE
           PERFORM TPL-ADD-VAR.
           
      * pasa los datos de memoria a la forma
       600-MEM-TO-FORM.
           MOVE "CLAVE" TO VAR-NAME
           MOVE LS-CLAVE TO VAR-VALUE
           PERFORM TPL-ADD-VAR.

           MOVE "RAZSOC"      TO VAR-NAME
           MOVE LS-RAZSOC    TO VAR-VALUE
           PERFORM TPL-ADD-VAR

           MOVE "NOMBRE"      TO VAR-NAME
           MOVE LS-NOMBRE    TO VAR-VALUE
           PERFORM TPL-ADD-VAR.

           MOVE "DIRECCION"   TO VAR-NAME
           MOVE LS-DIRECCION TO VAR-VALUE
           PERFORM TPL-ADD-VAR.

           MOVE "POBLACION"   TO VAR-NAME
           MOVE LS-POBLACION TO VAR-VALUE
           PERFORM TPL-ADD-VAR.

           MOVE "CODIGO"      TO VAR-NAME
           MOVE LS-CODIGO    TO VAR-VALUE
           PERFORM TPL-ADD-VAR.

           MOVE "TELEFONOS"   TO VAR-NAME
           MOVE LS-TELEFONOS TO VAR-VALUE
           PERFORM TPL-ADD-VAR.

           MOVE "RFC"         TO VAR-NAME
           MOVE LS-RFC       TO VAR-VALUE
           PERFORM TPL-ADD-VAR.

           MOVE "CUENTACTB"   TO VAR-NAME
           MOVE LS-CUENTACTB TO VAR-VALUE
           PERFORM TPL-ADD-VAR

           MOVE "DESCUENTO"   TO VAR-NAME
           MOVE LS-DESCUENTO TO L-DESCUENTO
           MOVE L-DESCUENTO   TO VAR-VALUE
           PERFORM TPL-ADD-VAR.

           MOVE "PLAZO"        TO VAR-NAME
           MOVE LS-PLAZO-NORMAL TO VAR-VALUE
           PERFORM TPL-ADD-VAR.
           
           
       700-PREPARA-FIRST.
           MOVE ZEROS TO C03-CLAVE
           START CLIENTES KEY IS NOT LESS THAN C03-LLAVE
                 INVALID KEY MOVE SPACE TO IK.

       700-PREPARA-PREV.
           MOVE LS-CLI-FIN TO C03-CLAVE
           START CLIENTES KEY IS NOT LESS THAN C03-LLAVE
                  INVALID KEY MOVE SPACE TO IK.
           IF STAT-CAT = "00"
              PERFORM 700-REG-PAGINA 2 TIMES.

       700-PREPARA-NEXT.
           MOVE LS-CLI-FIN TO C03-CLAVE.
           START CLIENTES KEY IS NOT LESS THAN C03-CLAVE
                  INVALID KEY MOVE SPACE TO IK.

       700-PREPARA-LAST.
           MOVE 999999 TO C03-CLAVE.
           START CLIENTES KEY IS LESS THAN C03-LLAVE
                 INVALID KEY MOVE SPACE TO IK.
           IF STAT-CAT = "00"
              READ CLIENTES PREVIOUS RECORD
              PERFORM 700-REG-PAGINA.

       700-REG-PAGINA.
           PERFORM VARYING I FROM 1 BY 1 UNTIL I > MAX-ROWS
              IF STAT-CAT = "00"
                 READ CLIENTES PREVIOUS RECORD
                 END-READ
              END-IF
           END-PERFORM.





       700-BROWSE-ALL.
           PERFORM 700-PREPARA-FIRST.
           PERFORM 700-BROWSE.

       700-BROWSE.
           MOVE "tpl\menu\act_cli_browse.html" TO TPL-FILENAME.
           PERFORM TPL-ADD-FILENAME.

           MOVE 0 TO FLAG-ROW.
           MOVE 0 TO I.
           PERFORM 700-LLENA-TABLA THRU 750-EXIT.
           MOVE "CLI-FIN" TO VAR-NAME
           MOVE C03-CLAVE TO VAR-VALUE
           PERFORM TPL-ADD-VAR.

       700-LLENA-TABLA.
           READ CLIENTES NEXT RECORD AT END GO 750-EXIT.
           
           IF STAT-CAT NOT = "00"
              GO 750-EXIT.
           
           MOVE "CLAVE" TO VAR-NAME.
           MOVE C03-CLAVE TO VAR-VALUE.
           PERFORM TPL-ADD-VAR.
           
           MOVE "NOMBRE" TO VAR-NAME.
           MOVE C03-NOMBRE TO VAR-VALUE.
           PERFORM TPL-ADD-VAR.
           
           IF FLAG-ROW = 0
              MOVE "ROW1"  TO BLOCK-NAME
              MOVE 1 TO FLAG-ROW
           ELSE
              MOVE "ROW2" TO BLOCK-NAME
              MOVE 0 TO FLAG-ROW.
           MOVE "TABLA" TO BLOCK-PASTE.
           PERFORM TPL-OPEN-BLOCK.
           
           ADD 1 TO I.
           IF I = MAX-ROWS
              GO 750-EXIT.
           
           GO 700-LLENA-TABLA.
       750-EXIT.
           EXIT.
           




       
       900-ERROR-OPEN.
           MOVE "<CENTER><BIG>" TO HTML-COMMAND.
           PERFORM TPL-DISP-COMMAND.
           
           MOVE "ERROR AL ABRIR CATALOGO DE CLIENTES" TO HTML-COMMAND.
           PERFORM TPL-DISP-COMMAND.
           
           STRING "<BR>ARCHIVO = ", WF-CLIENTES
                  DELIMITED BY SIZE INTO HTML-COMMAND.
           PERFORM TPL-DISP-COMMAND.
           
           STRING "<BR>ESTATUS DEL ARCHIVO = ", STAT-CAT
                  DELIMITED BY SIZE INTO HTML-COMMAND.
           PERFORM TPL-DISP-COMMAND.
           
           MOVE "</BIG></CENTER>" TO HTML-COMMAND.
           PERFORM TPL-DISP-COMMAND.


       COPY "COBLIB\TEMPLATE.FDT".

       999-EXIT.

       EXIT-PROG.
           EXIT PROGRAM.

       END PROGRAM.

